% This script generates a figure using the output 
% of the ideal observer models.
% Florent Meyniel 2019.

% Plot generative probabilities
ax(1) = subplot(4, 1, 1);
plot(1:L, [gen_p1g2; gen_p2g1]')
xlim([1 L]); ylim([0 1]); 
ylabel('Generative probabilities'); legend({'p(1|2)', 'p(2|1)'})
xlabel('observation #')

% Plot posterior distributions
ax(2) = subplot(4, 1, 2);
imagesc(1:L, in.opt.pgrid, out.p1g2_dist, [0 0.15])
set(gca, 'YDir', 'Normal')
ylabel('Posterior p(1|2)')
xlabel('observation #')
ax(3) = subplot(4, 1, 3);
imagesc(1:L, in.opt.pgrid, out.p2g1_dist, [0 0.15])
set(gca, 'YDir', 'Normal')
ylabel('Posterior p(2|1)')
xlabel('observation #')

% Plot mean and std
ax(4) = subplot(8, 1, 7);
plot(1:L, [out.p1g2_mean; out.p2g1_mean]'); ylim([0 1])
ylabel({'Posterior'; 'mean'}); xlim([1 L])

ax(5) = subplot(8, 1, 8);
plot(1:L, -log([out.p1g2_sd; out.p2g1_sd])')
ylabel({'Posterior'; 'confidence'}); xlim([1 L])
linkaxes(ax,'x')
